

visibility = {};

function visibility.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function visibility:load(xmlFile)

    numparts = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.parts#count"), 0);
	self.parts = {};
    for i=1, numparts do
        local partnamei = string.format("vehicle.parts.part%d", i);
        self.parts[i] = Utils.indexToObject(self.components, getXMLString(xmlFile, partnamei .. "#index"));
        setVisibility(self.parts[i], false);
    end;
	self.partsActive = false;
	
	numparts2 = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.parts2#count"), 0);
	self.parts2 = {};
    for i=1, numparts2 do
        local partnamei = string.format("vehicle.parts2.part%d", i);
        self.parts2[i] = Utils.indexToObject(self.components, getXMLString(xmlFile, partnamei .. "#index"));
        setVisibility(self.parts2[i], false);
    end;
	self.parts2Active = false;

	numparts3 = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.parts3#count"), 0);
	self.parts3 = {};
    for i=1, numparts3 do
        local partnamei = string.format("vehicle.parts3.part%d", i);
        self.parts3[i] = Utils.indexToObject(self.components, getXMLString(xmlFile, partnamei .. "#index"));
        setVisibility(self.parts3[i], false);
    end;
	self.parts3Active = false;

	numparts4 = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.parts4#count"), 0);
	self.parts4 = {};
    for i=1, numparts4 do
        local partnamei = string.format("vehicle.parts4.part%d", i);
        self.parts4[i] = Utils.indexToObject(self.components, getXMLString(xmlFile, partnamei .. "#index"));
        setVisibility(self.parts4[i], false);
    end;
	self.parts4Active = false;

	numparts5 = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.parts5#count"), 0);
	self.parts5 = {};
    for i=1, numparts5 do
        local partnamei = string.format("vehicle.parts5.part%d", i);
        self.parts5[i] = Utils.indexToObject(self.components, getXMLString(xmlFile, partnamei .. "#index"));
        setVisibility(self.parts5[i], false);
    end;
	self.parts5Active = false;

	numparts6 = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.parts6#count"), 0);
	self.parts6 = {};
    for i=1, numparts6 do
        local partnamei = string.format("vehicle.parts6.part%d", i);
        self.parts6[i] = Utils.indexToObject(self.components, getXMLString(xmlFile, partnamei .. "#index"));
        setVisibility(self.parts6[i], false);
    end;
	self.parts6Active = false;

	numparts7 = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.parts7#count"), 0);
	self.parts7 = {};
    for i=1, numparts7 do
        local partnamei = string.format("vehicle.parts7.part%d", i);
        self.parts7[i] = Utils.indexToObject(self.components, getXMLString(xmlFile, partnamei .. "#index"));
        setVisibility(self.parts7[i], false);
    end;
	self.parts7Active = false;
end;

function visibility:keyEvent(unicode, sym, modifier, isDown)

	if isDown and sym == Input.KEY_KP_8 then 
	  self.partsActive = not self.partsActive;
	end;
	if isDown and sym == Input.KEY_k then 
		self.parts2Active = not self.parts2Active;
	end;
	if isDown and sym == Input.KEY_KP_5 then 
		self.parts3Active = not self.parts3Active;
	end;
	if isDown and sym == Input.KEY_KP_divide then 
		self.parts4Active = not self.parts4Active;
	end;
	if isDown and sym == Input.KEY_j then 
		self.parts5Active = not self.parts5Active;
	end;
	if isDown and sym == Input.KEY_l then 
		self.parts6Active = not self.parts6Active;
	end;
	if isDown and sym == Input.KEY_7 then 
		self.parts7Active = not self.parts7Active;
	end;

end;


function visibility:update(dt)

  if self.partsActive then
		for i=1, numparts do
			setVisibility(self.parts[i], self.partsActive);
		end;
	        else
		for i=1, numparts do
			setVisibility(self.parts[i], self.partsActive, false);
	    end;
	end;
   if self.parts2Active then
		for i=1, numparts2 do
			setVisibility(self.parts2[i], self.parts2Active);
		end;
	        else
		for i=1, numparts2 do
			setVisibility(self.parts2[i], self.parts2Active, false);
	    end;	
	end;
   if self.parts3Active then
		for i=1, numparts3 do
			setVisibility(self.parts3[i], self.parts3Active);
		end;
	        else
		for i=1, numparts3 do
			setVisibility(self.parts3[i], self.parts3Active, false);
	    end;	
	end;
   if self.parts4Active then
		for i=1, numparts4 do
			setVisibility(self.parts4[i], self.parts4Active);
		end;
	        else
		for i=1, numparts4 do
			setVisibility(self.parts4[i], self.parts4Active, false);
	    end;	
	end;
   if self.parts5Active then
		for i=1, numparts5 do
			setVisibility(self.parts5[i], self.parts5Active);
		end;
	        else
		for i=1, numparts5 do
			setVisibility(self.parts5[i], self.parts5Active, false);
	    end;	
	end;
   if self.parts6Active then
		for i=1, numparts6 do
			setVisibility(self.parts6[i], self.parts6Active);
		end;
	        else
		for i=1, numparts6 do
			setVisibility(self.parts6[i], self.parts6Active, false);
	    end;	
	end;
   if self.parts7Active then
		for i=1, numparts7 do
			setVisibility(self.parts7[i], self.parts7Active);
		end;
	        else
		for i=1, numparts7 do
			setVisibility(self.parts7[i], self.parts7Active, false);
	    end;	
    end;
end;

function visibility:draw()
end;

function visibility:onEnter()

end;

function visibility:onLeave()
end;

function visibility:delete()
end;

function visibility:mouseEvent(posX, posY, isDown, isUp, button)
end;